from Products.PloneTestCase.PloneTestCase import PloneTestCase

from Products.PolicyTestCase import patches


class PolicyTestCase(PloneTestCase):
    
    def __init__(self, methodName='runTest', state=None):
        self.state = state
        test_methodName = 'test_%s' % methodName
        state_items = state.items()
        state_items.sort()
        for key,value in state_items:
            test_methodName = "%s_%s" % (test_methodName, str(value))

        method = getattr(self, methodName)
        setattr(self, test_methodName, method)

        PloneTestCase.__init__(self, test_methodName)

    def assertNotRaises(self, exception, callable, *args, **kwargs):
        """A call may not raise the given exception.
            
        It may raise a different exception, or no exception.
        """
        try:
            callable(*args, **kwargs)
        except exception:
            self.fail("%s was raised." % exception.__name__)

