import sys,time

Xscenarios = (
    'ListProject',
    'ViewProject',
    'EditProject',
    'ListContent',
    'ViewContent',
    'EditContent',
    'AddContent',
    'DeleteContent',
    'SubmitContent',
    'PublishContent',
    'RetractContent',
    'ManageMembership',
    )

res = {}

exception = ''
lastkey = ''
lastscen = ''

for line in sys.stdin.readlines():
#for line in open('/tmp/output').readlines():
    line = line.strip()
    if not line:
        continue

    if line.find('PolicyTestCase') < 0 or line.find('Result: ') < 0:
        exception += line
        continue

    junk, result, test = line.split(': ')
    bits = test.split('_')
    junk = bits[0]
    scenario = bits[1]
    key = tuple(bits[2:])

    if scenario.startswith('No'):
        scenario = scenario[2:]
        yn = 'N'
    else:
        yn = 'Y'

    if key not in res:
        res[key] = {}
    res[key][scenario] = (yn,result,'')

    # exception comes after the result, so we need to stick it in
    # the last result we got
    if lastkey and lastscen:
        old = res[lastkey][lastscen]
        res[lastkey][lastscen] = (old[0], old[1], exception)

    lastkey = key
    lastscen = scenario
    exception = ''

lres = res.items()
lres.sort()

scenarios = None

print 'Generated: %s<br/ >' % time.asctime()
print '<table border="1" cellpadding="2">'
for row, col in lres:
    if scenarios is None:
        print "<tr>"
        for x in row:
            print "<td></td>"

        scenarios = col.keys()
        for pos in scenarios:
            print "<td>%s</td>" % pos


    print "<tr>"
    for item in row:
        print "<td>%s</td>" % item
    for pos in scenarios:
        yn,result,exception = col.get(pos, ('XXX','XXX',''))
        if result == "Success":
            bgcolor = "#99FF99"
        elif result == "Failure":
            bgcolor = "#FF6666"
        else:
            bgcolor = "#FFFF00"
        exceptionhtml = """<div style="display: none; text-align: left;">%s</div>""" % exception
        print """<td align="center" bgcolor="%s" onclick="div = this.getElementsByTagName('div')[0]; div.style.display = (div.style.display == 'none') ? 'block' : 'none';">%s%s</td>"""  \
            % (bgcolor, yn, exceptionhtml)

    print "</tr>"

print "</table>"
