from unittest import TestSuite

def assertNotRaises(self, exception, callable, *args, **kwargs):
    """A call may not raise the given exception.
    
    It may raise a different exception, or no exception.
    """
    try:
        callable(*args, **kwargs)
    except exception:
        self.fail("%s was raised." % exception.__name__)



def sortTuple(t):
    l = list(t)
    l.sort()
    return tuple(l)


def makeSuiteFromCSV(TestClass, csv):
    # First grab the header and parse out the variables
    header = csv.readline()
    header_fields = header.split(',')
    header_fields = [ field.strip() for field in header_fields ]
    state_variables = [ field[1:] for field in header_fields if field.startswith('_') ]
    num_state_variables = len(state_variables)
    scenarios = [ field for field in header_fields if not field.startswith('_') ]
    num_scenarios = len(scenarios)

    tests = TestSuite()

    # Now process the main bit of the CSV
    for line in csv.readlines():
        line = line.strip()
        bits = line.split(',')
        bits = [ x.strip() for x in bits ]
        state = {}
        for x in range(num_state_variables):
            state[state_variables[x]] = bits[x]

        # Go through the scenarios and create the methods
        for x in range(num_scenarios):
            scenario = scenarios[x]
            yn = bits[num_state_variables + x]
            if yn == 'Y':
                tests.addTest(TestClass(scenario, state))
            elif yn =='N':
                tests.addTest(TestClass('No'+scenario, state))
            else:
                raise ValueError, 'Invalid response, must be Y/N: %s' % yn

    return tests
